package com.AndPskmail;

import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.media.AudioManager;

public class mBroadcastReceiver extends BroadcastReceiver {

	@Override
	public void onReceive(Context myContext, Intent intent) {
		try {

			String action = intent.getAction();
			//		BluetoothDevice device =
			//				intent.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
			if (action.equals(BluetoothAdapter.ACTION_STATE_CHANGED)) {
				int state = intent.getIntExtra(BluetoothAdapter.EXTRA_STATE,
						BluetoothAdapter.ERROR);
				switch (state) {
				case BluetoothAdapter.STATE_ON:
					//Bluetooth Adapter is now turned ON, wait for the device to connect
					//The connection should occur automatically if the Bluetooth device 
					//  was ON and already paired with phone/tablet
					break;
				case BluetoothAdapter.STATE_TURNING_OFF:
					//Stop the SCO connection 
					AndPskmail.toBluetooth = false;
					AndPskmail.mAudioManager.setBluetoothScoOn(false);
					AndPskmail.mAudioManager.stopBluetoothSco();
					AndPskmail.mAudioManager.setMode(AudioManager.MODE_NORMAL);
					break;
				}
			} else if (action.equals(BluetoothDevice.ACTION_ACL_CONNECTED)) {
				//The device has connected, now we can launch the SCO channel
				if (Double.valueOf(android.os.Build.VERSION.SDK) >= 8.0) {
					//Start the SCO connection and let the state change below complete the link
					AndPskmail.mAudioManager.startBluetoothSco();
				} else {
					// Android 2.1 Needs testinband.apk to be launched now 
					//Intent LaunchIntent = AndPskmail.context.getPackageManager().getLaunchIntentForPackage("com.guru.testinband");
					// AndPskmail.context.startActivity( LaunchIntent );
				}
			} else if (action.equals(BluetoothDevice.ACTION_ACL_DISCONNECTED)) {
				//The device has connected, now we can launch the SCO channel
				if (Double.valueOf(android.os.Build.VERSION.SDK) >= 8.0) {
					//Start the SCO connection and let the state change below complete the link
					//Stop the SCO connection 
					AndPskmail.scoChannelOn = false; //Can't be on
					AndPskmail.toBluetooth = false;
					AndPskmail.mAudioManager.setBluetoothScoOn(false);
					AndPskmail.mAudioManager.stopBluetoothSco();
					AndPskmail.mAudioManager.setMode(AudioManager.MODE_NORMAL);
				} else {
					// Android 2.1 Needs testinband.apk to be launched now 
					//Intent LaunchIntent = AndPskmail.context.getPackageManager().getLaunchIntentForPackage("com.guru.testinband");
					// AndPskmail.context.startActivity( LaunchIntent );
				}
			} else if (action.equals(AudioManager.ACTION_SCO_AUDIO_STATE_CHANGED)) {

				int state = intent.getIntExtra(AudioManager.EXTRA_SCO_AUDIO_STATE,
						-1);
				switch (state) {
				case AudioManager.SCO_AUDIO_STATE_CONNECTED:
					//The SCO channel is open, set the device to use it
					AndPskmail.mAudioManager.setMode(AudioManager.MODE_IN_CALL);
					AndPskmail.mAudioManager.setBluetoothScoOn(true);
					AndPskmail.toBluetooth = true;
					AndPskmail.scoChannelOn = true;
					break;
				case AudioManager.SCO_AUDIO_STATE_DISCONNECTED:
					AndPskmail.scoChannelOn = false;
					AndPskmail.toBluetooth = false;
					AndPskmail.mAudioManager.setBluetoothScoOn(false);
					AndPskmail.mAudioManager.stopBluetoothSco();
					AndPskmail.mAudioManager.setMode(AudioManager.MODE_NORMAL);
					if (AndPskmail.mBluetoothAdapter != null) {
						if (AndPskmail.mBluetoothAdapter.isEnabled()) {
							AndPskmail.mBluetoothAdapter.disable(); 
						} 
					}

					break;
				default:
					//Do nothing
					break;
				}

			}
		} catch (Exception ex) {
			loggingclass.writelog("Error in BR" + ex.getMessage(),
					null, true);
			// System.out.println(ex.getMessage());
		}

	}
}